package com.qmth.sop.business.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.sop.business.bean.result.LoginResult;
import com.qmth.sop.business.bean.result.SysUserResult;
import com.qmth.sop.business.entity.SysUser;
import com.qmth.sop.common.enums.AppSourceEnum;

import java.security.NoSuchAlgorithmException;
import java.util.List;

/**
 * <p>
 * 用户表 服务类
 * </p>
 *
 * @author wangliang
 * @since 2023-07-17
 */
public interface SysUserService extends IService<SysUser> {

    /**
     * 登录公用
     *
     * @param password
     * @param sysUser
     * @param appSource
     * @return
     * @throws NoSuchAlgorithmException
     */
    public LoginResult login(String password, SysUser sysUser, AppSourceEnum appSource) throws NoSuchAlgorithmException;

    /**
     * 删除用户信息
     *
     * @param userId
     * @param all
     */
    public Boolean removeUserInfo(Long userId, boolean all) throws NoSuchAlgorithmException;

    /**
     * 根据机构id查询用户
     *
     * @param orgId
     * @return
     */
    List<SysUserResult> findSysUserResultList(Long orgId);

    /**
     * 强行过期用户手机号验证码（过期时间改为验证码发送时间）
     *
     * @param userId       用户id
     * @param mobileNumber 用户手机号
     */
    void expiredVerifyCode(Long userId, String mobileNumber);

    /**
     * 校验短信验证码
     *
     * @param userId       用户id
     * @param mobileNumber 用户手机号
     * @param code         验证码
     */
    void checkSmsCode(Long userId, String mobileNumber, String code);
}
